/***************************************************************************
                          dspushbutton.h  -  description
                             -------------------
    begin                : Don Okt 30 2003
    copyright            : (C) 2003 by Dominik Seichter
    email                : domseichter@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DSPUSHBUTTON_H
#define DSPUSHBUTTON_H

#include <qwidget.h>
#include <kpushbutton.h>
#include <qvaluestack.h>
#include <qstring.h>

#include "dragiface.h"

class QDragEnterEvent;
class QDropEvent;
class QMouseEvent;

/**
  *@author Dominik Seichter
  */

class DSPushButton : public KPushButton, public DCOPIface {
    Q_OBJECT
    public: 
        DSPushButton(QWidget *parent=0, const char *name=0);
        ~DSPushButton();

    public slots:
        void clear();
        int count() const;
        void run();

        void push( KURL url );
        KURL pop();

    signals:
        void about();

    private slots:
        void remove();
        void top(int i);

    protected:
        void dragEnterEvent(QDragEnterEvent* event);
        void dropEvent(QDropEvent* event);
        void mouseMoveEvent( QMouseEvent* e );
        void mousePressEvent( QMouseEvent* e );
        void mouseReleaseEvent( QMouseEvent* e );

    private:
        void updateIcon();

        QPoint presspos;
        bool pressed;
        QValueStack<QStringList> files;
};

#endif
